import { aws_glue as glue } from 'aws-cdk-lib';
import * as constructs from 'constructs';
export declare enum GlueClassifierType {
    /**
     * A classifier for comma-separated values (CSV).
     */
    CSV = "CSV",
    /**
     * A classifier that uses grok
     */
    GROK = "GROK",
    /**
     * A classifier for JSON content.
     */
    JSON = "JSON",
    /**
     * A classifier for XML content.
     */
    XML = "XML"
}
export interface GlueClassifierProps {
    readonly name: string;
    readonly type: GlueClassifierType;
    readonly csvClassifier?: glue.CfnClassifier.CsvClassifierProperty;
    readonly grokClassifier?: glue.CfnClassifier.GrokClassifierProperty | undefined;
    readonly jsonClassifier?: glue.CfnClassifier.JsonClassifierProperty | undefined;
    readonly xmlClassifier?: glue.CfnClassifier.XMLClassifierProperty | undefined;
}
export declare class GlueClassifier extends constructs.Construct {
    name: string;
    classifier: glue.CfnClassifier | undefined;
    constructor(scope: constructs.Construct, id: string, props: GlueClassifierProps);
}
